// Adventure Mayhem - Custom Enemies

freeslot(
	"MT_INSTANTDETON",
	"MT_LOOKTURRET",
	"MT_SILENTCOMMANDER",
	"S_INSTANTDETON",
	"S_INSTANTDETON_DEATH",
	"S_LOOKTURRET_LOOK",
	"S_LOOKTURRET_WARMUP",
	"S_LOOKTURRET_FIRE",
	"S_LOOKTURRET_STOP"
)

// Instant Deton - The normal Deton has too slow of a reaction time, so I made a faster one

local function Deton_Explode(mo, var1, var2)
	P_RadiusAttack(mo, mo, 96*FRACUNIT, 0, true)
	local explodeMo = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
	explodeMo.momx = (P_RandomByte() % 32) * explodeMo.scale/8
	explodeMo.momy = (P_RandomByte() % 32) * explodeMo.scale/8
	explodeMo = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
	explodeMo.momx = (P_RandomByte() % 64) * explodeMo.scale/8
	explodeMo.momy = (P_RandomByte() % 64) * explodeMo.scale/8
	explodeMo = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
	explodeMo.momx = (P_RandomByte() % 128) * explodeMo.scale/8
	explodeMo.momy = (P_RandomByte() % 128) * explodeMo.scale/8
	S_StartSound(explodeMo, sfx_pop)
	explodeMo = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
	explodeMo.momx = (P_RandomByte() % 96) * explodeMo.scale/8
	explodeMo.momy = (P_RandomByte() % 96) * explodeMo.scale/8
	S_StartSound(explodeMo, sfx_cybdth)
end

states[S_INSTANTDETON] =	{SPR_DETN,	A,	1,	A_Look,	0,	0,	S_INSTANTDETON}
states[S_INSTANTDETON_DEATH] =	{SPR_NULL,	A,	0,	Deton_Explode,	0,	0,	S_XPLD_FLICKY}

mobjinfo[MT_INSTANTDETON] = {
	//$Name Instant Deton
	//$Sprite DETNA1
	//$Category Enemies
	doomednum = 199,
	spawnstate = S_INSTANTDETON,
	spawnhealth = 1,
	seestate = S_DETON2,
	seesound = sfx_none,
	reactiontime = 1,
	attacksound = sfx_deton,
	painchance = 3072,
	deathstate = S_INSTANTDETON_DEATH,
	deathsound = sfx_pop,
	speed = FRACUNIT,
	radius = 20*FRACUNIT,
	height = 32*FRACUNIT,
	damage = 1,
	flags = MF_ENEMY|MF_SHOOTABLE|MF_NOGRAVITY|MF_MISSILE,
	raisestate = ANG15
}

// Look Turret - A version of the turret that uses A_Look

states[S_LOOKTURRET_LOOK] =		{SPR_TRET,	A|FF_FULLBRIGHT,	1,		A_Look,			0,	0,	S_LOOKTURRET_LOOK}
states[S_LOOKTURRET_WARMUP] =	{SPR_TRET,	A|FF_FULLBRIGHT,	105,	A_TurretStop,	0,	0,	S_LOOKTURRET_FIRE}
states[S_LOOKTURRET_FIRE] =		{SPR_TRET,	A|FF_FULLBRIGHT,	105,	A_TurretFire,	0,	0,	S_LOOKTURRET_STOP}
states[S_LOOKTURRET_STOP] =		{SPR_TRET,	A|FF_FULLBRIGHT,	1,		A_TurretStop,	1,	0,	S_LOOKTURRET_LOOK}

mobjinfo[MT_LOOKTURRET] = {
	//$Name "Look Turret"
	//$Sprite TRETA1
	//$Category Enemies
	doomednum = 198,
	spawnstate = S_LOOKTURRET_LOOK,
	spawnhealth = 1000,
	seestate = S_LOOKTURRET_WARMUP,
	reactiontime = 8,
	attacksound = sfx_trfire,
	painsound = sfx_fizzle,
	deathstate = S_TURRETSHOCK1,
	deathsound = sfx_pop,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	mass = MT_TURRETLASER,
	damage = 1,
	activesound = sfx_trpowr,
	flags = MF_SPECIAL|MF_SHOOTABLE|MF_FIRE|MF_NOCLIPTHING // Special thanks to Glaber's Badnik Pack DX for the flags
}

mobjinfo[MT_SILENTCOMMANDER] = {
	//$Name Silent Crawla Commander
	//$Sprite CCOMA1
	//$Category Enemies
	doomednum = 197,
	spawnstate = S_CCOMMAND1,
	spawnhealth = 2,
	seestate = S_CCOMMAND3,
	reactiontime = 2*TICRATE,
	painstate = S_CCOMMAND3,
	painchance = 200,
	painsound = sfx_dmpain,
	deathstate = S_XPLD_FLICKY,
	deathsound = sfx_pop,
	speed = 3,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	mass = 100,
	activesound = sfx_s3k5d,
	flags = MF_SLIDEME|MF_ENEMY|MF_SPECIAL|MF_SHOOTABLE
}
